#!/usr/bin/python

#
#        +-----------------------------------------------------------------------------+
#        | Endian Firewall                                                             |
#        +-----------------------------------------------------------------------------+
#        | Copyright (c) 2005-2006 Endian                                              |
#        |         Endian GmbH/Srl                                                     |
#        |         Bergweg 41 Via Monte                                                |
#        |         39057 Eppan/Appiano                                                 |
#        |         ITALIEN/ITALIA                                                      |
#        |         info@endian.it                                                      |
#        |                                                                             |
#        | This program is free software; you can redistribute it and/or               |
#        | modify it under the terms of the GNU General Public License                 |
#        | as published by the Free Software Foundation; either version 2              |
#        | of the License, or (at your option) any later version.                      |
#        |                                                                             |
#        | This program is distributed in the hope that it will be useful,             |
#        | but WITHOUT ANY WARRANTY; without even the implied warranty of              |
#        | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
#        | GNU General Public License for more details.                                |
#        |                                                                             |
#        | You should have received a copy of the GNU General Public License           |
#        | along with this program; if not, write to the Free Software                 |
#        | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
#        | http://www.fsf.org/                                                         |
#        +-----------------------------------------------------------------------------+
#


from os import system as run
import os.path
from os import unlink
import signal
from os import path

from Cheetah.Template import Template
from Cheetah.Tools import RecursiveNull


# catch the signal.
signal.signal(signal.SIGHUP, signal.SIG_DFL)

VAR="/var/efw/clamav/"
ETC="/etc/clamav/"
FRESHCONF="freshclam.conf"
CLAMCONF="clamd.conf"

def touch(filename):
    open(filename, 'a').close()

def getconfig(filename):
    """
    Reads a configuration file and returns a hash
    """
    config = {}
    try:
	for line in open(filename).xreadlines():
	    line = line.strip()
	    if line and line[0] != '#':
	        line = line.split("=", 1)
		config[line[0]] = line[1]
    except:
        print "# Error reading config %s" % filename
        return {}
    return config

def write_file(source, destination, p):

    tmpl = open(source, 'r')
    data = tmpl.read()
    tmpl.close()

    conf = open(destination, 'w')
    conf.write((data % p))
    conf.close()

def write_config(TEMPLATE,CONF_FILE,VALUES):
    VALUES = alter_config(VALUES)

    null = RecursiveNull.RecursiveNull()
    t = Template(file=TEMPLATE, searchList=[VALUES, null])
    t2 = Template(t.respond(), searchList=[VALUES,null])

    content = t2.respond()
    file = open(CONF_FILE, 'w')
    file.write(content)
    file.close()


def alter_config(VALUES):
    if os.path.exists('/etc/FLASH'):
        VALUES['ARCHIVE_MAXFILESIZE'] = '15'
    return VALUES

def writeconfig():
    config_values = {}
    if os.path.exists(VAR+"/default/settings"):
        config_values.update(getconfig(VAR+"/default/settings"))
    if os.path.exists(VAR+"/settings"):
        config_values.update(getconfig(VAR+"/settings"))
    write_config(path.join(ETC, FRESHCONF+".tmpl"), path.join(ETC, FRESHCONF), config_values)
    write_config(path.join(ETC, CLAMCONF+".tmpl"), path.join(ETC, CLAMCONF), config_values)

def stop():
    run("/usr/bin/killall clamd > /dev/null 2>&1")

def start():
    run("/usr/local/bin/restartfreshclam.py")
   
    if os.path.exists(VAR+"/enable_http") or \
           os.path.exists(VAR+"/enable_pop") or \
           os.path.exists(VAR+"/enable_ftp") or \
           os.path.exists(VAR+"/enable_smtp"):
        writeconfig()
        run("/usr/bin/freshclam")
        run("/usr/sbin/clamd")
        
	# monitor service
	if os.path.exists("/usr/bin/monit"):
            run("monit monitor clamavd")
	if os.path.exists("/var/efw/monit/services/"):
	    touch("/var/efw/monit/services/clamavd")    	
    else:
        if os.path.exists("/usr/bin/monit"):
            run("monit unmonitor clamavd")
	if os.path.exists("/var/efw/monit/services/clamavd"):
	    unlink("/var/efw/monit/services/clamavd")

def compatibiliy():
    if os.path.exists(VAR+"/enable"):
        run("/bin/touch "+VAR+"/enable_http")
        run("/bin/touch "+VAR+"/enable_pop")
        run("/bin/touch "+VAR+"/enable_smtp")
        run("/bin/touch "+VAR+"/enable_ftp")
        unlink(VAR+"/enable")

stop()
compatibiliy()
start()

