#!/usr/bin/python

#
#        +-----------------------------------------------------------------------------+
#        | Endian Firewall                                                             |
#        +-----------------------------------------------------------------------------+
#        | Copyright (c) 2005-2006 Endian                                              |
#        |         Endian GmbH/Srl                                                     |
#        |         Bergweg 41 Via Monte                                                |
#        |         39057 Eppan/Appiano                                                 |
#        |         ITALIEN/ITALIA                                                      |
#        |         info@endian.it                                                      |
#        |                                                                             |
#        | This program is free software; you can redistribute it and/or               |
#        | modify it under the terms of the GNU General Public License                 |
#        | as published by the Free Software Foundation; either version 2              |
#        | of the License, or (at your option) any later version.                      |
#        |                                                                             |
#        | This program is distributed in the hope that it will be useful,             |
#        | but WITHOUT ANY WARRANTY; without even the implied warranty of              |
#        | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
#        | GNU General Public License for more details.                                |
#        |                                                                             |
#        | You should have received a copy of the GNU General Public License           |
#        | along with this program; if not, write to the Free Software                 |
#        | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
#        | http://www.fsf.org/                                                         |
#        +-----------------------------------------------------------------------------+
#

from glob import glob
from os import unlink
from os import path
import os
from sys import exit

S_SETTINGS_DEFAULT="/var/efw/clamav/default/settings"
S_SETTINGS="/var/efw/clamav/settings"

SCRIPT="/usr/lib/clamav/freshclam.cron"

def getconfig(filename):
    """
    Reads a configuration file and returns a hash
    """
    config = {}
    try:
        for line in open(filename).xreadlines():
            line = line.strip()
            if line and line[0] != '#':
                line = line.split("=", 1)
                config[line[0]] = line[1]
    except:
        print "# Error reading config %s" % filename
        return {}
    return config

s_conf = getconfig(S_SETTINGS_DEFAULT)
if os.path.exists(S_SETTINGS):
    s_conf.update(getconfig(S_SETTINGS))

map(lambda x: unlink(x), glob("/etc/cron.*/freshclam"))

if s_conf['UPDATE_SCHEDULE'] in ['hourly', 'weekly', 'daily', 'monthly']:
    target = path.join("/etc/cron." + s_conf['UPDATE_SCHEDULE'], "freshclam")
    os.symlink(SCRIPT, target)

exit(0)

